/******************************************************************************
 CDLOGDirector.c

		CDLOGDirector is a DialogDirector that creates its dialogs
		from DLOG/DITL resources. It may be used for both modal
		and modeless dialogs. Dialogs that are very simple, i.e.
		that require no custom behavior until the dialog is
		dismissed, can be implemented by using a CDLOGDirector.
		Anything more complex is best handled by subclassing CDLOGDirector
		and, at a minimum, overring the DoCommand method.
		
	SUPERCLASS = CDialogDirector
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#include "CDLOGDialog.h"
#include "CDecorator.h"
#include "CRadioGroupPane.h"
#include "Commands.h"
#include "SeqCommands.h"
#include "CApplication.h"
#include "CEditDoc.h"
#include "CDLOGCompSeqDirector.h"
#include "seq.h"


extern struct CDesktop *gDesktop;
extern CDecorator   *gDecorator;
extern CursHandle	gWatchCursor;		/* Watch cursor for waiting			*/


#define kBaseResID		  128

#define kMoveToFront      (WindowPtr)-1L	

#define kOn				  1
#define kOff			  0

#define kNilFilterProc    nil

#define kEmptyString	  "\p"

#define kErrorAlertID	  kBaseResID+3	

/*******************/
/***  Functions  ***/
/*******************/               


void		 	DoError(Str255	errorString, Boolean fatal);

/* see tech note 304 */
//pascal OSErr SetDialogDefaultItem(DialogPtr theDialog, short newItem)
//	= { 0x303C, 0x0304, 0xAA68 };
//pascal OSErr SetDialogCancelItem(DialogPtr theDialog, short newItem)
//	= { 0x303C, 0x0305, 0xAA68 };

/******************************************************************************
 IDLOGDirector
 
 	Initialize a DLOGDirector object. Creates a DLOGDialog using the
 	specified DLOGid.
******************************************************************************/

void CDLOGCompSeqDirector::IDLOGCompSeqDirector( short DLOGid,
		CDirectorOwner *aSupervisor)
{	
}


/************DoError ***/

void DoError(Str255	errorString, Boolean fatal)
{	

	ParamText(errorString, kEmptyString, kEmptyString, kEmptyString);
	StopAlert(kErrorAlertID, kNilFilterProc);
	
	if(fatal)
		ExitToShell();
}

	